function handles=m_gen_calc_struct_coords(handles)
% This function calculates the coordinates describing the structures. It
% only executes the calculation if the coordinates have not beeen
% calculated for the structure or needs to be rcalculated.

% PARENT: testSTORM.m
% CHILD: m_gen_struct.m

is_struct_calc=handles.seq_params.patterns.is_struct_calc;    % vector storing values for deciding whether the parameters describing structures needs to be recalculated
rand_seed_bool=get(handles.rand_gen_seed_checkbox,'Value'); % variable for using fixed or not fixed seed for random number generation


for idx_struct=1:length(is_struct_calc)  % goes through the individual patterns
    if rand_seed_bool
        rng(idx_struct);     % let this be the fix seed
    else
        % do nothing
    end
    if is_struct_calc{idx_struct}==0     % if the coordinates of the structure needs to be recalculated
        params.sample=handles.seq_params.sample{idx_struct};
        pattern_coords=m_gen_struct(params);     %calculates the coordinates
        handles.seq_params.patterns.struct_coords{idx_struct}=pattern_coords;        % coordinates of the segments or the triangle defining some kind of structures
        handles.seq_params.patterns.is_struct_calc{idx_struct}=1;
    end
end

end
