function evaluate_localizations_make_plots(seq_path)

info_file=dir([seq_path,filesep,'*_param_infos.mat']);
load([seq_path,filesep,info_file(end).name])
load([seq_path,filesep,seq_params.filename,'_data_eval.mat'])
%%
eval_dir=[seq_path,filesep,seq_params.filename,'_eval_img'];
if ~isdir(eval_dir)
    mkdir(eval_dir)
end

%%

N_vals=unique([param_infos.N_photons]);
mol_vals=unique([param_infos.mol_shift_idx]);
N_indexes=[param_infos.N_photons];
mol_indexes=[param_infos.mol_shift_idx];

fields_to_plot={...
    ...'tol';...
    'intersection';...
    'jaccard';...
    'fscore';...
    'precision';...
    'recall';...
    'rmseLateral';...
    ...'rmseAxial';...
    'deltaX';...
    'deltaY';...
    ...'deltaZ';...
    };
h_f=figure('visible','off');
tol_values=5:5:150;
for idx_tol=1:length(tol_values)
    for field_name=fields_to_plot'
        eval(['mesh(mol_vals,N_vals,reshape([data_eval(idx_tol).val.',char(field_name),'],size(data_eval(idx_tol).val)));']);
        set(gca,'YScale','log')
        set(gca,'FontName','Times New Roman','Fontsize',14)
        view([-35 15])
        title(char(field_name))
        xlabel('Position Index')
        ylabel('Photons Per Spot')
        xlim([mol_indexes(1) mol_indexes(end)])
        ylim([N_vals(1) N_vals(end)])
        saveas(gcf,[eval_dir,filesep,seq_params.filename,'_eval_',char(field_name),'_',num2str(tol_values(idx_tol),'%3.3i')],'emf')
        clf
    end
end
close(h_f)

%%


fields_to_plot={...
    ...'tol';...
    'intersection';...
    'jaccard';...
    'fscore';...
    'precision';...
    'recall';...
    'rmseLateral';...
    ...'rmseAxial';...
    'deltaX';...
    'deltaY';...
    ...'deltaZ';...
    };
h_f=figure('visible','off');
tol_values=5:5:150;
for idx_tol=1:length(tol_values)
    for field_name=fields_to_plot'
        eval(['plot(N_vals,mean(reshape([data_eval(idx_tol).val.',char(field_name),'],size(data_eval(idx_tol).val)),2));']);
        set(gca,'XScale','log')
        set(gca,'FontName','Times New Roman','Fontsize',14)
        ylabel(char(field_name))
        xlabel('Photons Per Spot')
        xlim([N_vals(1) N_vals(end)])
        saveas(gcf,[eval_dir,filesep,seq_params.filename,'_eval2_',char(field_name),'_',num2str(tol_values(idx_tol),'%3.3i')],'emf')
        clf
    end
end
close(h_f)


