global m_gen_path
output_dir=[m_gen_path,filesep,'images'];

tic
rng('default')

% Sample parameter settings
seq_params=[];
% N of molecules, x, y, z, coordinates, the Radius of a vesicule.
seq_params.sample.name='vesicule';
seq_params.sample.vesicule_params=[...
    300000   0   0  0    2;...
    ];
seq_params.sample.link_rad=2; % radius of the linker in nm


tic
molecule_pos=m_gen_mol_coord(seq_params.sample.name,seq_params.sample,1);
toc

%%
temp_init=[molecule_pos.init_pos];
temp_cont=zeros(3,length(molecule_pos));
for qwe=1:length(molecule_pos)
    temp_cont(:,qwe)=molecule_pos(qwe).vesicule.contact_point;
end

idx=((temp_cont(3,:))<1.1 & (temp_cont(3,:))>0.9) &...
    (abs(temp_cont(2,:))<0.1);
% idx=ones(1,length(temp_cont(3,:)));
figure
scatter3(temp_init(1,idx),...
    temp_init(2,idx),...
    temp_init(3,idx))
hold all
scatter3(temp_cont(1,idx),...
    temp_cont(2,idx),...
    temp_cont(3,idx))
quiver3(temp_cont(1,idx),...
    temp_cont(2,idx),...
    temp_cont(3,idx),...
    temp_init(1,idx)-temp_cont(1,idx),...
    temp_init(2,idx)-temp_cont(2,idx),...
    temp_init(3,idx)-temp_cont(3,idx),...
    0,'ShowArrowHead','off')
set(gca,'DataAspectRatio',[1 1 1])
%%
temp_d=(temp_init-temp_cont).^2;
temp_d=sqrt(sum(temp_d));
figure
plot(temp_d)

temp_d=(temp_cont).^2;
temp_d=sqrt(sum(temp_d));
figure
plot(temp_d)

