function output=m_gen_eval_localization(data_ref,data_test,tol)


frame_vals = intersect(data_ref(:,1), data_test(:,1), 'rows');

intersection = 0;
% union = 0;
rmseLateral = 0;
rmseAxial = 0;
jaccard = 0;
fscore = 0;
deltaX = 0;
deltaY = 0;
deltaZ = 0;

N_total_fluoro_ref=length(data_ref(:,1));
N_total_fluoro_test=length(data_test(:,1));

for idx_frame=1:length(frame_vals)
    ref = data_ref(data_ref(:,1)==frame_vals(idx_frame),:);
    test = data_test(data_test(:,1)==frame_vals(idx_frame),:);
    
    N_ref = length(ref(:,1));
    N_test = length(test(:,1));
%     N_pairs = min(N_ref,N_test);
    
    candidates = zeros(N_ref*N_test+1,4);
    idx_candidates = 1;
    for idx_ref = 1:N_ref
        for idx_test = 1:N_test
            dist_axial = abs(ref(idx_ref,4)-test(idx_test,4));
            dist_lateral=sqrt((ref(idx_ref,2)-test(idx_test,2)).^2+(ref(idx_ref,3)-test(idx_test,3)).^2);
            if dist_axial<tol.axial && dist_lateral<tol.lateral
                candidates(idx_candidates,:) = [dist_lateral idx_ref idx_test 0];
                idx_candidates = idx_candidates+1;
            end
        end
    end
    candidates(idx_candidates:end,:) = [];
    candidates_sorted = sortrows(candidates,1);
    for idx_candidates_sorted=1:length(candidates_sorted(:,1))
        if candidates_sorted(idx_candidates_sorted,4)==1;
            continue
        end
        idx_to_write=any([...
            candidates_sorted(:,2)==candidates_sorted(idx_candidates_sorted,2),...
            candidates_sorted(:,3)==candidates_sorted(idx_candidates_sorted,3)...
            ],2);
        candidates_sorted(idx_to_write,4)=1;
        intersection=intersection+1;
        idx_ref=candidates_sorted(idx_candidates_sorted,2);
        idx_test=candidates_sorted(idx_candidates_sorted,3);
        deltaX=deltaX+(test(idx_test,2)-ref(idx_ref,2));
        deltaY=deltaY+(test(idx_test,3)-ref(idx_ref,3));
        deltaZ=deltaZ+(test(idx_test,4)-ref(idx_ref,4));
        rmseAxial=rmseAxial+(test(idx_test,4)-ref(idx_ref,4))^2;
        rmseLateral=rmseLateral+(test(idx_test,2)-ref(idx_ref,2))^2+(test(idx_test,3)-ref(idx_ref,3))^2;
    end
    
end

TP = intersection;
FP = N_total_fluoro_test - TP;
FN = N_total_fluoro_ref - TP;
precision = TP / (TP + FP);
recall = TP / (TP + FN);
union = N_total_fluoro_ref + N_total_fluoro_test - intersection;
if (intersection > 0)
    deltaX = deltaX/intersection;
    deltaY = deltaY/intersection;
    deltaZ = deltaZ/intersection;
    rmseLateral = sqrt(rmseLateral / intersection);
    rmseAxial = sqrt(rmseAxial / intersection);
    jaccard = 100 * intersection / union;
    fscore = 2 * (precision * recall) / (precision + recall);
end

output.tol=tol;
output.intersection=intersection;
output.jaccard=jaccard;
output.fscore=fscore;
output.precision=precision;
output.recall=recall;
output.rmseLateral=rmseLateral;
output.rmseAxial=rmseAxial;
output.deltaX=deltaX;
output.deltaY=deltaY;
output.deltaZ=deltaZ;

