function [  ] = num_int(  )
%UNTITLED Summary of this function goes here
%   Detailed explanation goes here

sampling_number=20;       % number of sampling points for the numerical integration

% calculating the upper borders for the integration
x_upper_min=0.5;
x_upper_max=2;
dw=(x_upper_max-x_upper_min)/10;
x_upper=x_upper_min:dw:x_upper_max;   % upper borders of the integration

% constans for Simpson's rule
simpson_row_x=2*ones(1,sampling_number);
simpson_row_x(1,2:2:end)=4;
simpson_row_x(1,1)=1;
simpson_row_x(1,end)=1;
simpson_row_x=simpson_row_x/3;

% constans for my rule
custom_row_x=ones(1,sampling_number);
custom_row_x(1,1)=9/24;
custom_row_x(1,2)=28/24;
custom_row_x(1,3)=23/24;
custom_row_x(1,end)=9/24;
custom_row_x(1,end-1)=28/24;
custom_row_x(1,end-2)=23/24;

for i=1:length(x_upper)
    % sampling points for the Simpson and the custom integration
    dx_int=x_upper(i)/(sampling_number-1);
    x_int=0:dx_int:x_upper(i);
    
    dx_euler=x_upper(i)/sampling_number;
    x_euler=0:dx_euler:x_upper(i);
    
    % integrating Gaussian function
    %anat=erf(w(i))-erf(0);
    %custom=sum(exp(-x_int.^2)*dx_int.*custom_row_x)*2/sqrt(pi);
    %simpson=sum(exp(-x_int.^2)*dx_int.*simpson_row_x)*2/sqrt(pi);
    %euler=sum(exp(-x_euler.^2)*dx_euler)*2/sqrt(pi);
    
    % integrating sine function
    a=1.3;
    b=0.4;
    anat=(-cos(a*pi*x_upper(i))+cos(a*pi*0))/(a*pi)+b*x_upper(i);
    custom=sum((sin(a*pi*x_int)+b)*dx_int.*custom_row_x);
    simpson=sum((sin(a*pi*x_int)+b)*dx_int.*simpson_row_x);
    euler=sum((sin(a*pi*x_euler)+b)*dx_euler);
    
    error_custom(i)=1-custom/anat;
    error_simpson(i)=1-simpson/anat;
    error_euler(i)=1-euler/anat;
    
end

% plotting numerical errors
figure()
plot(error_custom)
title('error custom')
figure()
plot(error_simpson)
title('error simpson')
figure()
plot(error_euler)
title('error euler')

end

